#!/usr/local/bin/ruby

$LOAD_PATH << File.join(File.dirname(__FILE__),'..')

require 'context'

STDOUT.print "generating Context instances..."
STDOUT.flush

Boolean = [true,false]
Underline = (0..3)
$ary = []
Boolean.each do |typewriter|
    Boolean.each do |italic|
	Boolean.each do |strong_emphasis|
	    Boolean.each do |emphasis|
		Boolean.each do |bold|
		    Underline.each do |underline|
			c = Context.new
			
			c.bold = bold
			c.typewriter = typewriter
			c.italic = italic
			c.emphasis = emphasis
			c.strong_emphasis = strong_emphasis
			c.instance_eval {
			    _set_underline underline
			}
			#print_context(c)
			$ary << c
		    end
		end
	    end
	end
    end
end

STDOUT.print "done.\n"

def calc_result(method_name)
    time_start = Time.now

    result =
	[false,true].map { |pl_both|
	$ary.map { |from|
	    $ary.map { |to|
		from.send(method_name,to,pl_both)
	    }
	}
    }

    time_end = Time.now

    [result,(time_end-time_start)]
end

STDOUT.print "calculating with slow version..."
STDOUT.flush
result1,time1 = calc_result(:distance_min_est_tag_1)
STDOUT.print "done.\n"
STDOUT.print "slow version: #{time1} s.\n"

require 'context_sub.rb'
#require 'context_sub_impl.so'

STDOUT.print "calculating with fast version..."
STDOUT.flush
result2,time2 = calc_result(:distance_min_est_tag_1_fast)
STDOUT.print "done.\n"
STDOUT.print "fast version: #{time2} s.\n"

mismatch = 0
2.times do |b|
    $ary.size.times do |i|
	$ary.size.times do |j|
	    r1 = result1[b][i][j]
	    r2 = result2[b][i][j]
	    if r1 != r2
		printf "mismatch! %03d,%03d -> #{r1} - #{r2}\n", i,j
		mismatch += 1
	    end
	end
    end
end
print "\n"
if mismatch == 0
    print "OK.\n"

    STDOUT.print "calculating with default version..."
    STDOUT.flush
    result3,time3 = calc_result(:distance_min_est_tag_1)
    STDOUT.print "done.\n"
    STDOUT.print "fast version: #{time3} s.\n"

    exit 0
else
    print "#{mismatch} mismatch(es)\n"
    exit 1
end
